<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
require_once 'lib/customlib/database/DbConfig.class.php';
require_once 'lib/customlib/common/date_conversion/DateConversion.php';

/**
 * Description of dataTableDBclass para ORACLE, con conector oci8
 *
 * @author gustavo
 */
class dataTableDB {

    //put your code here

    private $query;
    private $fieldList;
    private $searchFieldList;
    private $filterFieldList;
    private $fieldFormatedList;
    private $individualFieldFilterFlag = false;
    private $draw;
    private $start;
    private $length;
    private $iSortingCols;
    private $sSearch;
    private $sSearch_array;
    private $iSortingColsList;
    private $sSortDirList;
    private $sLimit;
    private $resultQuery;
    private $sOutput;
    private $db;
    private $resultSet;
    private $iTotal;
    private $iFilteredTotal;
    private $muchRows = false;
    private $maxRows_ForMuchRowsTable = 1000;
    private $maxRows_toProcess = 9999999;
    private $defaultEmptySet = false;
    private $disableCounter = false;
    
    private $columnList;

    public function dataTableDB() {
        $this->db = DbConfig::getDBConnection();
    }

    public function setMuchRows() {
        $this->muchRows = true;
        $this->defaultEmptySet = true;

        $this->iTotal = $this->maxRows_toProcess;
        $this->iFilteredTotal = $this->maxRows_toProcess;
    }

    public function setQuery($strQuery) {
        $this->query = $strQuery;
    }

    public function setQueryTable($table) {
        $this->query = "SELECT * FROM $table";
    }

    public function setFieldList(Array &$fieldList) {
        $this->fieldList = $fieldList;

        foreach ($fieldList as $key => $value) {
            $formattedField = new dtTableField($value);
            $this->fieldFormatedList[$value] = $formattedField;
        }
    }

    public function setTableFieldTypeasDate($fieldName, $fieldFomat) {
        $formattedField = $this->fieldFormatedList[$fieldName];
        $formattedField->setType(dtTableField::TYPE_DATE);
        $formattedField->setDisplayFormat($fieldFomat);
    }

    public function setFilterFieldList(Array &$filterFieldList) {

        $this->filterFieldList = $filterFieldList;
    }

    public function setSearchFieldList(Array &$searchFieldList) {

        $this->searchFieldList = $searchFieldList;
    }

    private function setVarsFromGet() {

        $this->draw = intval($_GET['draw']);
        $this->length = $_GET['length'];
        $this->start = $_GET['start'];
                       
        $this->order = $_GET['order'];

        if ( sizeof($this->order) > 0) {

            $this->iSortingCols = sizeof($this->order);
            $this->iSortingColsList = array();

            foreach ($this->order as $order) {
            	          
                if (is_int($order["column"]))
                    $sortField = intval($order["column"]);
                else 
                    $sortField = $order["column"];
                
                $sortOrder = $order["dir"];
                $this->iSortingColsList[$sortField] = $sortOrder;
                                
            }
        }
        
        
        $_column_get_params = $_GET['columns'];
        
        $this->columnList = new dtColumnList($_column_get_params);
        
        $this->sSearch_array = array();

        if ($this->columnList) {
                        
            foreach ($this->columnList->getColumnList() as $ndx=>$field) {
                               
            	// $filterValue = $this->columnList->getColumnFilterValue($i);
                $filterValue = $field->getSearchExpression();
                $fieldName = $field->getData();                                  
                
                if (!empty($filterValue) or $filterValue==="0") {
                    
                    $this->sSearch_array[$fieldName] = $filterValue;
                    $this->individualFieldFilterFlag = true;
                }
                $i++;
            }
        }
    }

    public function setPaging() {
        /* Paging */
        $this->sLimit = "";
        if (isset($this->start)) {
            // read 20 rows with an offset of 10
            $this->db->setLimit($this->length, $this->start);


            /**
              if ( ereg("WHERE", strtoupper($this->sWhere) ) ) {
              $this->sWhere .= " AND ";
              } else {
              $this->sWhere .= " WHERE ";
              }

              $this->sWhere .= "ROWNUM BETWEEN $this->start and $this->length";
             */
        }
    }

    public function setOrder() {

    	// FB::info($this->iSortingColsList);
    	
        /* Ordering */
        if (sizeof($this->iSortingCols) > 0) {
        
            if ($this->sOrder == "") {
                $this->sOrder = "ORDER BY  ";
                foreach ($this->iSortingColsList as $iSortCol => $sSortDir) {
                    
                    if (is_int($iSortCol) )
                         $this->sOrder .= $this->fnColumnToField($iSortCol) . " $sSortDir , ";
                    else
                        $this->sOrder .= " $iSortCol $sSortDir , ";
                }
                $this->sOrder = substr_replace($this->sOrder, "", -2);
                
                // FB::info($this->sOrder);
            }
        }
    }

    /* Filtering - NOTE this does not match the built-in DataTables filtering which does it
     * word by word on any field. It's possible to do here, but concerned about efficiency
     * on very large tables, and MySQL's regex functionality is very limited
     */

    public function setOrderBy($order) {

        $this->sOrder = "ORDER BY  " . $order;
    }

    private function setSearch() {

        $_lower = "lower";
        if (DbConfig::isOCI8())
            $_lower = "nls_lower";

        if ($this->sSearch != "") {

            if (is_array($this->searchFieldList)) {
                if (preg_match("/WHERE/", strtoupper($this->sWhere))) {
                    $this->sWhere .= " AND ";
                } else {
                    $this->sWhere .= " WHERE ";
                }

                foreach ($this->searchFieldList as $field) {
                    $this->sWhere .= " $_lower($field) LIKE '%" . strtolower($this->sSearch) . "%' OR ";
                }
                $this->sWhere = substr_replace($this->sWhere, "", -4);
            }
        }
    }

    private function setFilterByColumn() {

        if ($this->individualFieldFilterFlag) {

            $_lower = "lower";
            if (DbConfig::isOCI8())
                $_lower = "nls_lower";

            if (is_array($this->sSearch_array) and sizeof($this->sSearch_array) > 0) {


                if (preg_match("/WHERE/", strtoupper($this->sWhere))) {
                    $this->sWhere .= " AND ";
                } else {
                    $this->sWhere .= " WHERE ";
                }

                foreach ($this->sSearch_array as $field => $filterValue) {
                        $operando = " = ";
                	$filterValue = trim($filterValue);
                    if ($filterValue !== "") {
                    	$_not = "";
                        if (strpos($filterValue,"*") !== false) {
                                $filterValue = str_replace("*", "%", $filterValue);
                                $operando = " LIKE ";
                        }                                                    
                        if (substr($filterValue,0,1)==="!") {
                            $operando = " not LIKE ";
                            $filterValue = str_replace("!", " ", $filterValue);
                        }
                        $filterValue = trim($filterValue);
                           
                        $this->sWhere .= " $_lower($field) $operando '" . strtolower($filterValue) . "' AND ";
                            
                        
                    }
                }

                $this->sWhere = substr_replace($this->sWhere, "", -4);
            }
        }
    }

    private function setQueryTogether() {
        $this->resultQuery = $this->query;
        if ( preg_match("/where/", strtolower($this->query)) )
            $this->resultQuery = " select * from ( $this->query ) ax ";
        $this->resultQuery .= "
          $this->sWhere
          $this->sOrder
          $this->sLimit
      ";

        // echo $this->resultQuery;
    }

    private function emptySetApply() {
        return $this->defaultEmptySet and sizeof($this->sSearch_array) == 0;
    }

    private function ExecuteQuery() {
        // Proceed with a query...

        $_query = $this->resultQuery;        
        // FB::info($_query);
        
        if ($this->emptySetApply()) {
            $this->resultSet = false;
        } else {
            $this->resultSet = & $this->db->query($_query);
                        
        }

        // Always check that result is not an error
        if (PEAR::isError($this->resultSet)) {
            if (DEBUG) FB::info($_query);
            throw new Exception($this->resultSet->getMessage(), $this->resultSet->getCode());
        }
    }

    private function CalculateFoundRowsMysql() {
        if (!$this->disableCounter and ! $this->emptySetApply()) {
            $this->db->setLimit(false);
            //FB::info($this->resultQuery);
            $rsFilteredTotal = $this->db->query($this->resultQuery);
            $this->iTotal = $rsFilteredTotal->numRows();
            $this->iFilteredTotal = $rsFilteredTotal->numRows();
        }
    }

    private function CalculateFoundRowsOci8() {

        if (!$this->disableCounter) {
            $_query = "select count(*) as cant from (" . $this->resultQuery . ") ";
            $rsFilteredTotal = $this->db->query($_query);
            $this->db->query($_query);
            $aRow = $rsFilteredTotal->fetchRow(MDB2_FETCHMODE_ASSOC);
            $this->iFilteredTotal = $aRow["cant"];
            $this->iTotal = $aRow["cant"];
        }
    }

    private function CalculateFoundRows() {
        if (DbConfig::isOCI8()) {
            $this->CalculateFoundRowsOci8();
        } else {
            $this->CalculateFoundRowsMysql();
        }
    }

    private function CalculateTotalRowsMysql() {
        if (!$this->disableCounter) {
            /*
              $rsTotal = $this->db->query($this->query);
              $this->iTotal = $rsTotal->numRows();
              $this->iFilteredTotal = $rsTotal->numRows();
             *
             */
        	reset($this->fieldFormatedList);
        	$_first_field = current($this->fieldFormatedList);
        	        	
        	$_query = $this->query;
        	        	        	        
            $rsFilteredTotal = $this->db->query($_query);

            if (PEAR::isError($rsFilteredTotal)) {
                
                throw new Exception($rsFilteredTotal->getMessage(), $rsFilteredTotal->getCode());
            } else {

                $aRow = $rsFilteredTotal->fetchRow(MDB2_FETCHMODE_ASSOC);
                                                                               
                if ($this->iFilteredTotal == 0 or $this->iFilteredTotal == $this->maxRows_toProcess)
                    $this->iFilteredTotal = $aRow["cant"];
            }
        }
    }

    private function CalculateTotalRowsOci8() {

        if (!$this->disableCounter) {
            $_query = "select count(*) as cant from (" . $this->query . ") ";
            $rsFilteredTotal = $this->db->query($_query);
            $aRow = $rsFilteredTotal->fetchRow(MDB2_FETCHMODE_ASSOC);
            $this->iTotal = $aRow["cant"];
        }
    }

    private function CalculateTotalRows() {
        if (DbConfig::isOCI8()) {
            $this->CalculateTotalRowsOci8();
        } else {
            $this->CalculateTotalRowsMysql();
        }
    }

    public function processData() {

        $this->setVarsFromGet();
        $this->setPaging();
        $this->setOrder();
        $this->setSearch();
        $this->setFilterByColumn();
        $this->setQueryTogether();
        $this->ExecuteQuery();
        
        $this->CalculateFoundRows();
        // $this->CalculateTotalRows();
    }

    public function getOutputData() {

    	$sOutput = new stdClass();
        $sOutput->draw = $this->draw;
        $sOutput->recordsTotal = $this->iTotal;
        $sOutput->recordsFiltered = $this->iFilteredTotal;
        
        $aaData = array();
        while (	$this->resultSet and $aRow = $this->resultSet->fetchRow(MDB2_FETCHMODE_ASSOC )) {
            
            $data = new stdClass();
            foreach ($this->fieldFormatedList as $field) {
            	$_fieldName = $field->getName();

                if ($field->getType() != dtTableField::TYPE_DATE && $field->getType() != dtTableField::TYPE_DATE_TIME) {
                    $data->$_fieldName = $aRow[$_fieldName];
                } else {
                    $value = $field->getFormattedValue($aRow[$_fieldName]);
                    $data->$_fieldName = $value;
                }
            }

            $aaData[] = $data;
        }
        
        $sOutput->data = $aaData;

        $this->sOutput = $sOutput;

        $_ret = statusResponse::getInstanceOk();
        $_ret->setData($sOutput);
        
        return $_ret->getJsonEncoded();        
        
        // return json_encode($sOutput);
    }

    public function getOutputDataAutocomplete() {

        $sOutput &= $this->sOutput;

        $sOutput = '[';

        while ($this->resultSet and $aRow = $this->resultSet->fetchRow(MDB2_FETCHMODE_ASSOC)) {
        	

            $sOutput .= "{";

            foreach ($this->fieldFormatedList as $field) {

                $sOutput .= '"' . $field->getName() . '" : "' . addslashes($aRow[$field->getName()]) . '",';
            }

            $sOutput = substr_replace($sOutput, "", -1);
            $sOutput .= "},";
        }

        $sOutput = substr_replace($sOutput, "", -1);
        $sOutput .= ' ]';

        return $sOutput;
    }

    function fnColumnToField($i) {
        return $this->fieldList[$i];
    }

}

class dtTableField {

    const TYPE_DATE = "date";
    const TYPE_DATE_TIME = "datetime";

    private $name;
    private $columnName;
    private $type;                // date, nulo para otro;
    private $displayFormat = "";     // formato de display para mostrar p.e. fecha dd/mm/aaaa

    function dtTableField($name, $columnName = "", $type = "") {
        $this->name = $name;
        $this->columnName = $columnName;
        if ($columnName == "")
            $this->columnName = $name;
    }

    public function getFormattedValue($value) {
        if ($this->type == dtTableField::TYPE_DATE) {
            $_dateTime = DateConversion::DBFormatToDatetime($value);
            return DateConversion::ViewFormatFormDate($_dateTime);
        } elseif ($this->type == dtTableField::TYPE_DATE_TIME) {
            $_dateTime = DateConversion::DBFormatToDatetime($value);
            return DateConversion::ViewFormatForDateTime($_dateTime);
        }
    }

    public function getName() {
        return $this->name;
    }

    public function setName($name) {
        $this->name = $name;
    }

    public function getColumnName() {
        return $this->columnName;
    }

    public function setColumnName($columnName) {
        $this->columnName = $columnName;
    }

    public function getType() {
        return $this->type;
    }

    public function setType($type) {
        $this->type = $type;
    }

    public function getDisplayFormat() {
        return $this->displayFormat;
    }

    public function setDisplayFormat($displayFormat) {
        $this->displayFormat = $displayFormat;
    }

}



/**
 * 
 *  	
array(
[0] =>
array(

['data'] =>
0
['name'] =>
['searchable'] =>
'true'
['orderable'] =>
'true'
['search'] =>
array(

['value'] =>
'ggggg'
['regex'] =>
'false'
)
)
 *
 */
class dtColumnList {
	
	private $columnList = array();
	
	public function __construct($get_params) {
		
		if (sizeof($get_params) > 0 ) {
			foreach ($get_params as $ndx=>$value) {
				$this->columnList[$ndx] = new dtColumn($value);			
			}
		}
		
	}
	
	public function getColumnList() {
		return $this->columnList;		
	}
	
	/**
	 * 
	 * @param int $ndx
	 * @return dtColumn
	 */
	public function getColumn($ndx) {
		return $this->columnList[$ndx];
	}

	public function getColumnFilterValue($ndx) {
		$_col =  $this->columnList[$ndx];
		if ($_col) 
			return $_col->getSearchValue();
		return false;
	}
	
	
}

class dtColumn {
	
	private $data;
	private $name;
	private $searchable;
	private $orderable;
	private $search;
	
	public function __construct($get_params) {
		
		$this->data = $get_params['data'];
		$this->name = $get_params['name'];
		$this->searchable = $get_params['searchable'];
		$this->orderable = $get_params['orderable'];
		$this->search = $get_params['search'];
				
	}
        
        public function getName() {
            return $this->name;
        }
        
        public function getData() {
            return $this->data;
        }
	
	public function getSearch() {
		return $this->search;
	}
        
        public function getSearchExpression() {
            return $this->search["value"];
        }
	
	public function getSearchValue() {
            $_ret = false;

            if ($this->search)
                    $_ret = $this->search["value"];

            return $_ret;
		
	}	
}




?>